//** changed by F|RES [99-07-26]
//** void dynaHelpDDiv(unsigned __int32 op0,unsigned __int32 op1)
//** void dynaHelpDDivU(unsigned __int32 op0,unsigned __int32 op1)

#ifdef TRWIN
	#define WIDTH_MULT 2
#else
	#define WIDTH_MULT 1
#endif


unsigned __int16 dynaOpSra(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=dynaLoadReg(cp+l,op1);
	l+=SRA_REG_IMM(cp+l,dynaMapToNative[op1].Reg,op2);
	dynaSwitchMap(op0,op1);
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dynaOpSrl(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=dynaLoadReg(cp+l,op1);
	l+=SRL_REG_IMM(cp+l,dynaMapToNative[op1].Reg,op2);
	dynaSwitchMap(op0,op1);
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dynaOpSll(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=dynaLoadReg(cp+l,op1);
	l+=SLL_REG_IMM(cp+l,dynaMapToNative[op1].Reg,op2);
	dynaSwitchMap(op0,op1);
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dynaOpSraV(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=PUSH_REGISTER(cp+l,NATIVE_2);			// save ecx
	l+=dynaLoadRegForceNot(cp+l,op1,NATIVE_2);	// must not be ecx
	l+=dynaLoadRegForce(cp+l,op2,NATIVE_2);		// must be ecx
	l+=AND_REG_IMM(cp+l,dynaMapToNative[op2].Reg,0x1f);
	l+=SRA_REG_REG(cp+l,dynaMapToNative[op1].Reg,dynaMapToNative[op2].Reg);
	dynaSwitchMap(op0,op1);
	if(op0!=op2)
		dynaKillNative(NATIVE_2);
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	l+=POP_REGISTER(cp+l,NATIVE_2);			// save ecx
	return(l);
}

unsigned __int16 dynaOpSrlV(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=PUSH_REGISTER(cp+l,NATIVE_2);			// save ecx
	l+=dynaLoadRegForceNot(cp+l,op1,NATIVE_2);	// must not be ecx
	l+=dynaLoadRegForce(cp+l,op2,NATIVE_2);		// must be ecx
	l+=AND_REG_IMM(cp+l,dynaMapToNative[op2].Reg,0x1f);
	l+=SRL_REG_REG(cp+l,dynaMapToNative[op1].Reg,dynaMapToNative[op2].Reg);
	dynaSwitchMap(op0,op1);
	if(op0!=op2)
		dynaKillNative(NATIVE_2);
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	l+=POP_REGISTER(cp+l,NATIVE_2);			// save ecx
	return(l);
}

unsigned __int16 dynaOpSllV(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=PUSH_REGISTER(cp+l,NATIVE_2);			// save ecx
	l+=dynaLoadRegForceNot(cp+l,op1,NATIVE_2);	// must not be ecx
	l+=dynaLoadRegForce(cp+l,op2,NATIVE_2);		// must be ecx
	l+=AND_REG_IMM(cp+l,dynaMapToNative[op2].Reg,0x1f);
	l+=SLL_REG_REG(cp+l,dynaMapToNative[op1].Reg,dynaMapToNative[op2].Reg);
	dynaSwitchMap(op0,op1);
	if((op0!=op2)&&(op1!=op2))
		dynaKillNative(NATIVE_2);
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	l+=POP_REGISTER(cp+l,NATIVE_2);			// save ecx
	return(l);
}

unsigned __int16 dynaOpMfHi(unsigned char *cp,unsigned char op0)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*8;
	SrcOff=HI;
	l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);
	return(l);
}

unsigned __int16 dynaOpRegMove(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*8;
	SrcOff=op1*8;
	l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	return(l);
}

unsigned __int16 dynaOpRegDMove(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*8;
	SrcOff=op1*8;
	l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);
	return(l);
}

unsigned __int16 dyanOpAddEqual(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=ADD_REG_TO_DWORD(cp+l,dynaMapToNative[op1].Reg,op0*8);
	dynaKillNative(dynaMapToNative[op1].Reg);
	//fixme, killnative should not be needed later
	return(l);
}


unsigned __int16 dyanOpAdd(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=ADD_DWORD_TO_REG(cp+l,dynaMapToNative[op1].Reg,op2*8);
	dynaSwitchMap(op0,op1);
	//force the store here
	l+=dynaTmpFlushSgnReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}


unsigned __int16 dyanOpSubEqual(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=SUB_REG_FROM_DWORD(cp+l,dynaMapToNative[op1].Reg,op0*8);
	dynaKillNative(dynaMapToNative[op1].Reg);
	//fixme, killnative should not be needed later
	return(l);
}


unsigned __int16 dyanOpSub(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=SUB_DWORD_FROM_REG(cp+l,dynaMapToNative[op1].Reg,op2*8);
	dynaSwitchMap(op0,op1);
	//force the store here
	l+=dynaTmpFlushSgnReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}


unsigned __int16 dyanOpAndEqual(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=AND_REG_WITH_DWORD(cp+l,dynaMapToNative[op1].Reg,op0*8);
	dynaKillNative(dynaMapToNative[op1].Reg);
	//fixme, killnative should not be needed later
	return(l);
}


unsigned __int16 dyanOpAnd(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=AND_DWORD_WITH_REG(cp+l,dynaMapToNative[op1].Reg,op2*8);
	dynaSwitchMap(op0,op1);
	//force the store here
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dyanOpOrEqual(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=OR_REG_WITH_DWORD(cp+l,dynaMapToNative[op1].Reg,op0*8);
	dynaKillNative(dynaMapToNative[op1].Reg);
	//fixme, killnative should not be needed later
	return(l);
}


unsigned __int16 dyanOpOr(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=OR_DWORD_WITH_REG(cp+l,dynaMapToNative[op1].Reg,op2*8);
	dynaSwitchMap(op0,op1);
	//force the store here
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dyanOpNorEqual(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=OR_REG_WITH_DWORD(cp+l,dynaMapToNative[op1].Reg,op0*8);
	l+=NOT_DWORD(cp+l,op0*8);
	dynaKillNative(dynaMapToNative[op1].Reg);
	//fixme, killnative should not be needed later
	return(l);
}


unsigned __int16 dyanOpNor(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=OR_DWORD_WITH_REG(cp+l,dynaMapToNative[op1].Reg,op2*8);
	l+=NOT_REG(cp+l,dynaMapToNative[op1].Reg);
	dynaSwitchMap(op0,op1);
	//force the store here
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dyanOpXorEqual(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=XOR_REG_WITH_DWORD(cp+l,dynaMapToNative[op1].Reg,op0*8);
	dynaKillNative(dynaMapToNative[op1].Reg);
	//fixme, killnative should not be needed later
	return(l);
}


unsigned __int16 dyanOpXor(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=XOR_DWORD_WITH_REG(cp+l,dynaMapToNative[op1].Reg,op2*8);
	dynaSwitchMap(op0,op1);
	//force the store here
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dynaOpMtHi(unsigned char *cp,unsigned char op0)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	unsigned __int32 DstOff,SrcOff;
	SrcOff=op0*8;
	DstOff=HI;
	l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);
	return(l);
}


unsigned __int16 dynaOpMfLo(unsigned char *cp,unsigned char op0)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*8;
	SrcOff=LO;
	l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);
	return(l);
}


unsigned __int16 dynaOpMtLo(unsigned char *cp,unsigned char op0)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	unsigned __int32 DstOff,SrcOff;
	SrcOff=op0*8;
	DstOff=LO;
	l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);


	return(l);
}

unsigned __int16 dynaOpMult(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=dynaLoadRegForce(cp+l,op0,NATIVE_0);			// mov eax,op0
//	l+=dynaLoadReg(cp+l,op1);						// mov ???,op1
	l+=IMUL(cp+l,op0,op1);	// imul op1
	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx	 - save HI unsigned __int32
	l+=CONVERT_TO_QWORD(cp+l);						// convert low unsigned __int32 to signed qword
	unsigned __int32 tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	l+=POP_REGISTER(cp+l,NATIVE_0);					// get edx back as eax
	l+=CONVERT_TO_QWORD(cp+l);						// convert high unsigned __int32 to signed qword
	tmp=HI;	
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in hi

	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);

	return(l);
}

unsigned __int16 dynaOpMultU(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=dynaLoadRegForce(cp+l,op0,NATIVE_0);			// mov eax,op0
//	l+=dynaLoadReg(cp+l,op1);						// mov ???,op1
	l+=MUL(cp+l,op0,op1);	// imul op1
	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx	 - save HI unsigned __int32
	l+=CONVERT_TO_QWORD(cp+l);						// convert low unsigned __int32 to signed qword
	unsigned __int32 tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	l+=POP_REGISTER(cp+l,NATIVE_0);					// get edx back as eax
	l+=CONVERT_TO_QWORD(cp+l);						// convert high unsigned __int32 to signed qword
	tmp=HI;	
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in hi

	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);

	return(l);
}


unsigned __int16 dynaOpDiv(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	unsigned __int16 fixup1Len,fixup2Len;
	unsigned char *fixup1Ptr,*fixup2Ptr;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_3,op1*8);	// check for div by zero... no Mips expection is thrown
	l+=CMP_REG_IMM(cp+l,NATIVE_3,0);
	fixup1Ptr=cp+l;
	fixup1Len=l;
	l+=JZ_SHORT(cp+l,0);

	l+=dynaLoadRegForce(cp+l,op0,NATIVE_0);			// mov eax,op0

//	l+=ZERO_REG(cp+l,NATIVE_3);						// mov edx,0
	l+=CONVERT_TO_QWORD(cp+l);
	l+=IDIV(cp+l,op0,op1);	// imul op1
	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx	 - save HI unsigned __int32
	l+=CONVERT_TO_QWORD(cp+l);						// convert low unsigned __int32 to signed qword
	unsigned __int32 tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	l+=POP_REGISTER(cp+l,NATIVE_0);					// get edx back as eax
	l+=CONVERT_TO_QWORD(cp+l);						// convert high unsigned __int32 to signed qword
	tmp=HI;	
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in hi

	JZ_SHORT(fixup1Ptr,(l-fixup1Len)-2);
	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);

	return(l);
}

unsigned __int16 dynaOpDivU(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	unsigned __int16 fixupLen;
	unsigned char *fixupPtr;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_3,op1*8);	// check for div by zero... no Mips expection is thrown
	l+=CMP_REG_IMM(cp+l,NATIVE_3,0);
	fixupPtr=cp+l;
	fixupLen=l;
	l+=JZ_SHORT(cp+l,0);

	l+=dynaLoadRegForce(cp+l,op0,NATIVE_0);			// mov eax,op0
	l+=ZERO_REG(cp+l,NATIVE_3);						// mov edx,0
//	l+=CONVERT_TO_QWORD(cp+l);
	l+=DIV(cp+l,op0,op1);	// imul op1
	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx	 - save HI unsigned __int32
	l+=CONVERT_TO_QWORD(cp+l);						// convert low unsigned __int32 to signed qword
	unsigned __int32 tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	l+=POP_REGISTER(cp+l,NATIVE_0);					// get edx back as eax
	l+=CONVERT_TO_QWORD(cp+l);						// convert high unsigned __int32 to signed qword
	tmp=HI;	
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in hi

	JZ_SHORT(fixupPtr,(l-fixupLen)-2);
	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);

	return(l);
}

unsigned __int16 dynaOpSlt(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1Len,fixup2Len;

//	l+=PUSH_REGISTER(cp+l,NATIVE_0);
//	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&SneekyAddress);
//	l+=CALL_REGISTER(cp+l,NATIVE_0);
//	l+=POP_REGISTER(cp+l,NATIVE_0);

	l+=INC_PC_COUNTER(cp+l);
	l+=dynaLoadReg(cp+l,op1);
	l+=CMP_DWORD_WITH_REG(cp+l,dynaMapToNative[op1].Reg,op2*8);
	fixup1Ptr=cp+l;
	fixup1Len=l;
	l+=JGE_SHORT(cp+l,0);
	unsigned __int32 tmp=1;
	l+=STORE_DWORD_TO_RBANK(cp+l,tmp,op0*8);
	fixup2Ptr=cp+l;
	fixup2Len=l;
	l+=JMP_SHORT(cp+l,0);
	tmp=0;
	JGE_SHORT(fixup1Ptr,(l-fixup1Len)-2);
	l+=STORE_DWORD_TO_RBANK(cp+l,tmp,op0*8);
	JMP_SHORT(fixup2Ptr,(l-fixup2Len)-2);
	dynaKillNative(dynaMapToNative[op1].Reg);
	return(l);
}

unsigned __int16 dynaOpSltU(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1Len,fixup2Len;

	l+=INC_PC_COUNTER(cp+l);
	l+=dynaLoadReg(cp+l,op1);
	l+=CMP_DWORD_WITH_REG(cp+l,dynaMapToNative[op1].Reg,op2*8);
	fixup1Ptr=cp+l;
	fixup1Len=l;
	l+=JAE_SHORT(cp+l,0);
	unsigned __int32 tmp=1;
	l+=STORE_DWORD_TO_RBANK(cp+l,tmp,op0*8);
	fixup2Ptr=cp+l;
	fixup2Len=l;
	l+=JMP_SHORT(cp+l,0);
	tmp=0;
	JAE_SHORT(fixup1Ptr,(l-fixup1Len)-2);
	l+=STORE_DWORD_TO_RBANK(cp+l,tmp,op0*8);
	JMP_SHORT(fixup2Ptr,(l-fixup2Len)-2);
	dynaKillNative(dynaMapToNative[op1].Reg);
	return(l);
}

unsigned __int16 dynaOpSltI(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1Len,fixup2Len;

//	l+=PUSH_REGISTER(cp+l,NATIVE_0);
//	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&SneekyAddress);
//	l+=CALL_REGISTER(cp+l,NATIVE_0);
//	l+=POP_REGISTER(cp+l,NATIVE_0);

	l+=INC_PC_COUNTER(cp+l);
	l+=dynaLoadReg(cp+l,op1);
	l+=CMP_REG_IMM(cp+l,dynaMapToNative[op1].Reg,Immediate);
	fixup1Ptr=cp+l;
	fixup1Len=l;
	l+=JGE_SHORT(cp+l,0);
	unsigned __int32 tmp=1;
	l+=STORE_DWORD_TO_RBANK(cp+l,tmp,op0*8);
	fixup2Ptr=cp+l;
	fixup2Len=l;
	l+=JMP_SHORT(cp+l,0);
	tmp=0;
	JGE_SHORT(fixup1Ptr,(l-fixup1Len)-2);
	l+=STORE_DWORD_TO_RBANK(cp+l,tmp,op0*8);
	JMP_SHORT(fixup2Ptr,(l-fixup2Len)-2);
	dynaKillNative(dynaMapToNative[op1].Reg);
	return(l);
}

unsigned __int16 dynaOpSltIU(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1Len,fixup2Len;

	l+=INC_PC_COUNTER(cp+l);
	l+=dynaLoadReg(cp+l,op1);
	l+=CMP_REG_IMM(cp+l,dynaMapToNative[op1].Reg,Immediate);
	fixup1Ptr=cp+l;
	fixup1Len=l;
	l+=JAE_SHORT(cp+l,0);
	unsigned __int32 tmp=1;
	l+=STORE_DWORD_TO_RBANK(cp+l,tmp,op0*8);
	fixup2Ptr=cp+l;
	fixup2Len=l;
	l+=JMP_SHORT(cp+l,0);
	tmp=0;
	JAE_SHORT(fixup1Ptr,(l-fixup1Len)-2);
	l+=STORE_DWORD_TO_RBANK(cp+l,tmp,op0*8);
	JMP_SHORT(fixup2Ptr,(l-fixup2Len)-2);
	dynaKillNative(dynaMapToNative[op1].Reg);
	return(l);
}


unsigned __int16 dyanOpAndIEqual(unsigned char *cp,unsigned char op0,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=AND_DWORD_WITH_IMM(cp+l,Immediate,op0*8);
	//fixme, killnative should not be needed later
	return(l);
}

unsigned __int16 dyanOpAndI(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=AND_REG_IMM(cp+l,dynaMapToNative[op1].Reg,Immediate);
	dynaSwitchMap(op0,op1);
	//force the store here
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dyanOpOrIEqual(unsigned char *cp,unsigned char op0,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=OR_IMM_WITH_DWORD(cp+l,Immediate,op0*8);
	//fixme, killnative should not be needed later
	return(l);
}

unsigned __int16 dyanOpOrI(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=OR_REG_IMM(cp+l,dynaMapToNative[op1].Reg,Immediate);
	dynaSwitchMap(op0,op1);
	//force the store here
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dyanOpXorIEqual(unsigned char *cp,unsigned char op0,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=XOR_IMM_WITH_DWORD(cp+l,Immediate,op0*8);
	//fixme, killnative should not be needed later
	return(l);
}

unsigned __int16 dyanOpXorI(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=dynaLoadReg(cp+l,op1);
	l+=XOR_REG_IMM(cp+l,dynaMapToNative[op1].Reg,Immediate);
	dynaSwitchMap(op0,op1);
	//force the store here
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[op0].Reg);
	return(l);
}

unsigned __int16 dyanOpDAddEqual(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_0);
	l+=PUSH_REGISTER(cp+l,NATIVE_3);
	l+=dynaLoadRegPair(cp+l,op1);
	l+=ADD_REG_TO_DWORD(cp+l,NATIVE_0,op0*8);
	l+=ADC_REG_TO_DWORD(cp+l,NATIVE_3,op0*8+4);
	l+=POP_REGISTER(cp+l,NATIVE_3);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	return(l);
}


unsigned __int16 dyanOpDAdd(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_0);
	l+=PUSH_REGISTER(cp+l,NATIVE_3);
	l+=dynaLoadRegPair(cp+l,op1);
	l+=ADD_DWORD_TO_REG(cp+l,NATIVE_0,op2*8);
	l+=ADC_DWORD_TO_REG(cp+l,NATIVE_3,op2*8+4);
	//force the store here
	l+=dynaTmpFlushRegPair(cp+l,op0);
	l+=POP_REGISTER(cp+l,NATIVE_3);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	return(l);
}


unsigned __int16 dyanOpDSubEqual(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_0);
	l+=PUSH_REGISTER(cp+l,NATIVE_3);
	l+=dynaLoadRegPair(cp+l,op1);
	l+=SUB_REG_FROM_DWORD(cp+l,NATIVE_0,op0*8);
	l+=SBB_REG_FROM_DWORD(cp+l,NATIVE_3,op0*8+4);
	l+=POP_REGISTER(cp+l,NATIVE_3);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	return(l);
}


unsigned __int16 dyanOpDSub(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_0);
	l+=PUSH_REGISTER(cp+l,NATIVE_3);
	l+=dynaLoadRegPair(cp+l,op1);
	l+=SUB_DWORD_FROM_REG(cp+l,NATIVE_0,op2*8);
	l+=SBB_DWORD_FROM_REG(cp+l,NATIVE_3,op2*8+4);
	//force the store here
	l+=dynaTmpFlushRegPair(cp+l,op0);
	l+=POP_REGISTER(cp+l,NATIVE_3);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	return(l);
}
/*
unsigned __int16 dynaOpDMult(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=dynaLoadRegForce(cp+l,op0,NATIVE_0);			// mov eax,op0
	l+=IMUL(cp+l,op0,op1);	// imul op1
	unsigned __int32 tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	tmp=HI;	
	l+=ZERO_REG(cp+l,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_0);			// save in hi

	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);

	return(l);
}

unsigned __int16 dynaOpDMultU(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=dynaLoadRegForce(cp+l,op0,NATIVE_0);			// mov eax,op0
	l+=MUL(cp+l,op0,op1);	// imul op1
	unsigned __int32 tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	tmp=HI;	
	l+=ZERO_REG(cp+l,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_0);			// save in hi

	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);

	return(l);
}
*/
void dynaHelpDDiv(unsigned __int32 op0,unsigned __int32 op1)
{
	if(*(__int64*)&m_Reg->r[op1*WIDTH_MULT] != 0)
	{
		m_Reg->Lo = *(__int64*)&m_Reg->r[op0*WIDTH_MULT] / *(__int64*)&m_Reg->r[op1*WIDTH_MULT];
		m_Reg->Hi = *(__int64*)&m_Reg->r[op0*WIDTH_MULT] % *(__int64*)&m_Reg->r[op1*WIDTH_MULT];
	}
}


void dynaHelpDDivU(unsigned __int32 op0,unsigned __int32 op1)
{
	if(*(__int64*)&m_Reg->r[op1*WIDTH_MULT] != 0)
	{
		m_Reg->Lo = *(unsigned __int64*)&m_Reg->r[op0*WIDTH_MULT] / *(unsigned __int64*)&m_Reg->r[op1*WIDTH_MULT];
		m_Reg->Hi = *(unsigned __int64*)&m_Reg->r[op0*WIDTH_MULT] % *(unsigned __int64*)&m_Reg->r[op1*WIDTH_MULT];
	}
}


unsigned __int16 dynaOpDDiv(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	unsigned __int16 fixup1Len,fixup2Len;
	unsigned char *fixup1Ptr,*fixup2Ptr;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_ALL(cp+l);
	l+=PUSH_DWORD(cp+l,op1);			//base
	l+=PUSH_DWORD(cp+l,op0);			//what
	l+=LOAD_REG_IMM(cp+l,NATIVE_0,(unsigned __int32)dynaHelpDDiv);
	l+=CALL_REGISTER(cp+l,NATIVE_0);	// the called address will return back to 'start'+0x50, which will be the
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_ALL(cp+l);

/*
	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_3,op1*8);	// check for div by zero... no Mips expection is thrown
	l+=CMP_REG_IMM(cp+l,NATIVE_3,0);
	fixup1Ptr=cp+l;
	fixup1Len=l;
	l+=JZ_SHORT(cp+l,0);

	l+=dynaLoadRegPair(cp+l,op0);

	l+=IDIV(cp+l,op0,op1);	// imul op1
	unsigned __int32 tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	tmp=HI;	
	l+=ZERO_REG(cp+l,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_0);			// save in hi

	JZ_SHORT(fixup1Ptr,(l-fixup1Len)-2);
	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);
*/

	return(l);
}

unsigned __int16 dynaOpDDivU(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	unsigned __int16 fixupLen;
	unsigned char *fixupPtr;

	l+=INC_PC_COUNTER(cp+l);

	l+=PUSH_ALL(cp+l);
	l+=PUSH_DWORD(cp+l,op1);			//base
	l+=PUSH_DWORD(cp+l,op0);			//what
	l+=LOAD_REG_IMM(cp+l,NATIVE_0,(unsigned __int32)dynaHelpDDivU);
	l+=CALL_REGISTER(cp+l,NATIVE_0);	// the called address will return back to 'start'+0x50, which will be the
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_ALL(cp+l);


/*
	l+=PUSH_REGISTER(cp+l,NATIVE_3);				// push edx

	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_3,op1*8);	// check for div by zero... no Mips expection is thrown
	l+=CMP_REG_IMM(cp+l,NATIVE_3,0);
	fixupPtr=cp+l;
	fixupLen=l;
	l+=JZ_SHORT(cp+l,0);

	l+=dynaLoadRegPair(cp+l,op0);
	l+=DIV(cp+l,op0,op1);	// imul op1
	unsigned __int32 tmp=LO;
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);			//
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_3);			// save in lo
	tmp=HI;	
	l+=ZERO_REG(cp+l,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp,NATIVE_0);
	l+=REG_TO_MEM_DWORD(cp+l,tmp+4,NATIVE_0);			// save in hi

	JZ_SHORT(fixupPtr,(l-fixupLen)-2);
	l+=POP_REGISTER(cp+l,NATIVE_3);					// recover edx

	dynaKillNative(NATIVE_0);
*/

	return(l);
}
unsigned __int16 dynaOpAddI(unsigned char *cp,unsigned char rt,unsigned char rs,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);
	l+=dynaLoadReg(cp+l,rs);
	l+=ADD_REG_IMM(cp+l,dynaMapToNative[rs].Reg,Immediate);
	// now switch the map so that RT is mapped rather than RS
	dynaSwitchMap(rt,rs);
	//force the store here
	l+=dynaTmpFlushReg(cp+l,dynaMapToNative[rt].Reg);
	return(l);
}


unsigned __int16 dynaOpAddIEqual(unsigned char *cp,unsigned char op0,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	l+=ADD_IMM_TO_RBANK(cp+l,Immediate,op0*8);
	return(l);
}


unsigned __int16 dynaOpLoadI(unsigned char *cp,unsigned char op0,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	l+=STORE_DWORD_TO_RBANK(cp+l,Immediate,op0*8);
	return(l);
}


unsigned __int16 dynaOpDAddIEqual(unsigned char *cp,unsigned char rt,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);
	l+=PUSH_REGISTER(cp+l,NATIVE_0);
	l+=PUSH_REGISTER(cp+l,NATIVE_3);
	l+=LOAD_REG_IMM(cp+l,NATIVE_0,Immediate);
	l+=CONVERT_TO_QWORD(cp+l);
	l+=ADD_REG_TO_DWORD(cp+l,NATIVE_0,rt*8);
	l+=ADC_REG_TO_DWORD(cp+l,NATIVE_3,rt*8+4);
	l+=POP_REGISTER(cp+l,NATIVE_3);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	return(l);
}


unsigned __int16 dynaOpDAddI(unsigned char *cp,unsigned char rt,unsigned char rs,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);
	unsigned __int32 DstOff,SrcOff;
	DstOff=rt*8;
	SrcOff=rs*8;
	l+=PUSH_REGISTER(cp+l,NATIVE_0);
	l+=PUSH_REGISTER(cp+l,NATIVE_3);
	l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);		//extra push/pop here - need to inline MEM_TO_MEM_QWORD
	l+=LOAD_REG_IMM(cp+l,NATIVE_0,Immediate);
	l+=CONVERT_TO_QWORD(cp+l);
	l+=ADD_REG_TO_DWORD(cp+l,NATIVE_0,rt*8);
	l+=ADC_REG_TO_DWORD(cp+l,NATIVE_3,rt*8+4);
	l+=POP_REGISTER(cp+l,NATIVE_3);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	return(l);
}


unsigned __int16 dynaOpDSllV(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=PUSH_REGISTER(cp+l,NATIVE_2);			// save ecx
	l+=dynaLoadRegForce(cp+l,op2,NATIVE_2);		// must be ecx
	l+=AND_REG_IMM(cp+l,NATIVE_2,0x3f);
	l+=dynaLoadRegPair(cp+l,op1);
	l+=SHLD_REG_REG(cp+l);
	l+=SLL_REG_REG(cp+l,NATIVE_0,NATIVE_2);
	l+=dynaTmpFlushRegPair(cp+l,op0);
	l+=POP_REGISTER(cp+l,NATIVE_2);
	return(l);
}

unsigned __int16 dynaOpDSll(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=dynaLoadRegPair(cp+l,op1);
	l+=SHLD_REG_IMM(cp+l,(unsigned char)Immediate);
	l+=SLL_REG_REG(cp+l,NATIVE_0,Immediate);
	l+=dynaTmpFlushRegPair(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpDSll32(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=dynaLoadRegPair(cp+l,op1);
	l+=NATIVE_REG_TO_REG(cp+l,NATIVE_3,NATIVE_0);	//edx=eax ie; shift left 32
	l+=ZERO_REG(cp+l,NATIVE_0);
	l+=SLL_REG_IMM(cp+l,NATIVE_3,Immediate&0x1f);
	l+=dynaTmpFlushRegPair(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpDSrlV(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=PUSH_REGISTER(cp+l,NATIVE_2);			// save ecx
	l+=dynaLoadRegForce(cp+l,op2,NATIVE_2);		// must be ecx
	l+=AND_REG_IMM(cp+l,NATIVE_2,0x3f);
	l+=dynaLoadRegPair(cp+l,op1);
	l+=SHRD_REG_REG(cp+l);
	l+=SRL_REG_REG(cp+l,NATIVE_0,NATIVE_2);
	l+=dynaTmpFlushRegPair(cp+l,op0);
	l+=POP_REGISTER(cp+l,NATIVE_2);
	return(l);
}

unsigned __int16 dynaOpDSrl(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=dynaLoadRegPair(cp+l,op1);
	l+=SHRD_REG_IMM(cp+l,(unsigned char)Immediate);
	l+=SRL_REG_REG(cp+l,NATIVE_0,Immediate);
	l+=dynaTmpFlushRegPair(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpDSrl32(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=dynaLoadRegPair(cp+l,op1);
	l+=NATIVE_REG_TO_REG(cp+l,NATIVE_0,NATIVE_3);	//edx=eax ie; shift left 32
	l+=ZERO_REG(cp+l,NATIVE_3);
	l+=SRL_REG_IMM(cp+l,NATIVE_0,Immediate&0x1f);
	l+=dynaTmpFlushRegPair(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpDSraV(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=PUSH_REGISTER(cp+l,NATIVE_2);			// save ecx
	l+=dynaLoadRegForce(cp+l,op2,NATIVE_2);		// must be ecx
	l+=AND_REG_IMM(cp+l,NATIVE_2,0x3f);
	l+=dynaLoadRegPair(cp+l,op1);
	l+=SHRD_REG_REG(cp+l);
	l+=SRA_REG_REG(cp+l,NATIVE_0,NATIVE_2);
	l+=dynaTmpFlushRegPair(cp+l,op0);
	l+=POP_REGISTER(cp+l,NATIVE_2);
	return(l);
}

unsigned __int16 dynaOpDSra(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=dynaLoadRegPair(cp+l,op1);
	l+=SHRD_REG_IMM(cp+l,(unsigned char)Immediate);
	l+=SRA_REG_REG(cp+l,NATIVE_0,(unsigned char)Immediate);
	l+=dynaTmpFlushRegPair(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpDSra32(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp);

	l+=dynaLoadRegPair(cp+l,op1);
	l+=NATIVE_REG_TO_REG(cp+l,NATIVE_0,NATIVE_3);	//edx=eax ie; shift left 32
	l+=SRA_REG_IMM(cp+l,NATIVE_0,(unsigned char)(Immediate&0x1f));
	l+=CONVERT_TO_QWORD(cp+l);
	l+=dynaTmpFlushRegPair(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpRs0Mf(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	if(op1==9)
	{
		l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,ICOUNT);
		l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,op0*8);
		l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,ICOUNT+4);
		l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,op0*8+4);
	}
	else
	{
		unsigned __int32 DstOff,SrcOff;
		DstOff=op0*8;
		SrcOff=CPR0+op1*8;
		l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	}
	return(l);
}

unsigned __int16 dynaOpRs0DMf(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	if(op1==9)
	{
		l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,ICOUNT);
		l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,op0*8);
		l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,ICOUNT+4);
		l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,op0*8+4);
	}
	else
	{
		unsigned __int32 DstOff,SrcOff;
		DstOff=op0*8;
		SrcOff=CPR0+op1*8;
		l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);
	}
	return(l);
}


unsigned __int16 dynaOpRs0Mt(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	if(op0==11) //compare
	{
		l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,op1*8);
	//	unsigned __int32 tmp=0x1234;
	//	l+=LOAD_REG_IMM(cp+l,NATIVE_0,tmp);
		l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,CCOUNT);
		l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,NCOUNT);
		l+=AND_DWORD_WITH_IMM(cp+l,CPR0+13*8,~0x00008000);
	}
	else if(op0==13) //cause
	{
		unsigned __int32 DstOff,SrcOff;
		SrcOff=op1*8;
		DstOff=CPR0+op0*8;
		l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
		l+=AND_DWORD_WITH_IMM(cp+l,CPR0+13*8,0x00000300);
	}
	else 
	{
		unsigned __int32 DstOff,SrcOff;
		SrcOff=op1*8;
		DstOff=CPR0+op0*8;
		l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	}
	return(l);
}

unsigned __int16 dynaOpRs0DMt(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	if(op0==11) //compare
	{
		l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,op1*8);
		l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,CCOUNT);
		l+=AND_DWORD_WITH_IMM(cp+l,CPR0+13*8,~0x00008000);
	}
	else if(op0==13) //cause
	{
		unsigned __int32 DstOff,SrcOff;
		SrcOff=op1*8;
		DstOff=CPR0+op0*8;
		l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
		l+=AND_DWORD_WITH_IMM(cp+l,CPR0+13*8,0x00000300);
	}
	else 
	{
		unsigned __int32 DstOff,SrcOff;
		SrcOff=op1*8;
		DstOff=CPR0+op0*8;
		l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);
	}
	return(l);
}

unsigned __int16 dynaOpRs1Mf(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*8;
	SrcOff=_FPR+op1*4;
	l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	return(l);
}

unsigned __int16 dynaOpRs1DMf(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*8;
	SrcOff=_FPR+op1*4;
	l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);
	return(l);
}

unsigned __int16 dynaOpRs1Mt(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	unsigned __int32 DstOff,SrcOff;
	SrcOff=op1*8;
	DstOff=_FPR+op0*4;
	l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	return(l);
}

unsigned __int16 dynaOpRs1DMt(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	unsigned __int32 DstOff,SrcOff;
	SrcOff=op1*8;
	DstOff=_FPR+op0*4;
	l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);
	return(l);
}

unsigned __int16 dynaOpRs1Ct(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	unsigned __int32 DstOff,SrcOff;
	SrcOff=op1*8;
	DstOff=CCR1+op0*8;
	l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	return(l);
}


unsigned __int16 dynaOpRs0Ct(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	unsigned __int32 DstOff,SrcOff;
	SrcOff=op1*8;
	DstOff=CCR0+op0*8;
	l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	return(l);
}


unsigned __int16 dynaOpRs1Cf(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*8;
	SrcOff=CCR1+op1*8;
	l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	return(l);
}


unsigned __int16 dynaOpRs0Cf(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*8;
	SrcOff=CCR0+op1*8;
	l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	return(l);
}

