#define RAW_ACCESS

unsigned __int16 dynaOpSw(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=LOAD_REG(cp+l,op0,NATIVE_0);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=PUSH_REGISTER(cp+l,NATIVE_0);	//what
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperStoreWordAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	return(l);
}



unsigned __int16 dynaOpLw(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperLoadWordAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_1);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	l+=STORE_REG(cp+l,op0,NATIVE_0);
	return(l);
}


unsigned __int16 dynaOpLwU(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperLoadWordAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_1);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	l+=STORE_REG(cp+l,op0,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpLui(unsigned char *cp,unsigned char op0,unsigned __int32 Imm)
{
	Imm<<=16;
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);
	l+=STORE_DWORD_TO_RBANK(cp+l,Imm,op0*8);

	return(l);
}

unsigned __int16 dynaOpLh(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=XOR_REG_IMM(cp+l,MEM_PTR,2);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=CONVERT_TO_DWORD(cp+l);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperLoadHalfAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_1);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	l+=STORE_REG(cp+l,op0,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpLb(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=XOR_REG_IMM(cp+l,MEM_PTR,3);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=CONVERT_TO_WORD(cp+l);
	l+=CONVERT_TO_DWORD(cp+l);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperLoadByteAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_1);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	l+=STORE_REG(cp+l,op0,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpLhU(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=XOR_REG_IMM(cp+l,MEM_PTR,2);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=AND_REG_IMM(cp+l,NATIVE_0,0x0000ffff);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperLoadHalfAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_1);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	l+=STORE_REG(cp+l,op0,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpLbU(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;


	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=XOR_REG_IMM(cp+l,MEM_PTR,3);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=AND_REG_IMM(cp+l,NATIVE_0,0x000000ff);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperLoadByteAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_1);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	l+=STORE_REG(cp+l,op0,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpLd(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;


	l+=PUSH_REGISTER(cp+l,NATIVE_3);
	l+=INC_PC_COUNTER(cp+l);

#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_3);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,4);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperLoadDWordAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_1);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,op0*8);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_3,op0*8+4);
	l+=POP_REGISTER(cp+l,NATIVE_3);
	return(l);
}

unsigned __int16 dynaOpSh(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=LOAD_REG(cp+l,op0,NATIVE_0);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=XOR_REG_IMM(cp+l,MEM_PTR,2);
	l+=STORE_MEM_WORD_REG(cp+l,MEM_PTR,NATIVE_0);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=PUSH_REGISTER(cp+l,NATIVE_0);	//what
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperStoreHalfAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	return(l);
}


unsigned __int16 dynaOpSb(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=LOAD_REG(cp+l,op0,NATIVE_0);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=XOR_REG_IMM(cp+l,MEM_PTR,3);
	l+=STORE_MEM_BYTE_REG(cp+l,MEM_PTR,NATIVE_0);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=PUSH_REGISTER(cp+l,NATIVE_0);	//what
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperStoreByteAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	return(l);
}


unsigned __int16 dynaOpSd(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);
#ifdef RAW_ACCESS
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=CMP_REG_IMM(cp+l,MEM_PTR,0xa0000000);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	fixup1Ptr=cp+l;
	fixup1l=l;
	l+=JZ_SHORT(cp+l,0);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,op0*8+4);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,op0*8);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,4);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	fixup2Ptr=cp+l;
	fixup2l=l;
	l+=JMP_SHORT(cp+l,0);
	JZ_SHORT(fixup1Ptr,(l-fixup1l)-2);
#endif
	l+=PUSH_REGISTER(cp+l,MEM_PTR);		//where
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,op0*8);
	l+=PUSH_REGISTER(cp+l,NATIVE_0);	//what
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,op0*8+4);
	l+=PUSH_REGISTER(cp+l,NATIVE_0);	//what
	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&helperStoreDWordAddress);
	l+=CALL_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
	l+=POP_REGISTER(cp+l,NATIVE_0);
#ifdef RAW_ACCESS
	JMP_SHORT(fixup2Ptr,(l-fixup2l)-2);
#endif
	return(l);
}

unsigned __int16 dynaOpLdlFull(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1,unsigned __int32 Part2)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=CLD(cp+l);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,PC_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,PC_PTR,tmp);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	tmp=4;
	l+=ADD_REG_IMM(cp+l,MEM_PTR,tmp);		// src+4 (upper unsigned __int32)
	l+=ADD_REG_IMM(cp+l,PC_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part2);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	return(l);
}


unsigned __int16 dynaOpLdlHalf(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=CLD(cp+l);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,PC_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,PC_PTR,tmp);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	return(l);
}

unsigned __int16 dynaOpLdl(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp+l);

//	l+=PUSH_REGISTER(cp+l,NATIVE_0);
//	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&SneekyAddress);
//	l+=CALL_REGISTER(cp+l,NATIVE_0);
//	l+=POP_REGISTER(cp+l,NATIVE_0);


	int Part1,Part2,Count;
	unsigned __int32 Offset;
	Offset=Immediate&7;
	Count=8-(int)Offset;
	Part1=Count-4;
	if(Count>=4) Part2=4;
	else Part2=Count;
	if(Part1>0)
	{
		l+=dynaOpLdlFull(cp+l,op0,op1,Immediate,Offset,Part1,Part2);
	}
	else
	{
		l+=dynaOpLdlHalf(cp+l,op0,op1,Immediate,Offset,Part2);
	}
	return(l);
}

unsigned __int16 dynaOpLdrFull(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1,unsigned __int32 Part2)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=STD(cp+l);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,PC_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,PC_PTR,tmp);
	l+=PUSH_REGISTER(cp+l,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_REGISTER(cp+l,MEM_PTR);
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part2);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	l+=CLD(cp+l);
	return(l);
}


unsigned __int16 dynaOpLdrHalf(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=STD(cp+l);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,PC_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,PC_PTR,tmp);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	l+=CLD(cp+l);
	return(l);
}

unsigned __int16 dynaOpLdr(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp+l);

//	l+=PUSH_REGISTER(cp+l,NATIVE_0);
//	l+=LOAD_REG_DWORD(cp+l,NATIVE_0,(unsigned char *)&SneekyAddress);
//	l+=CALL_REGISTER(cp+l,NATIVE_0);
//	l+=POP_REGISTER(cp+l,NATIVE_0);


	int Part1,Part2,Count;
	unsigned __int32 Offset;
	Offset=Immediate&7;
	Count=8-(int)Offset;
	Part1=Count-4;
	if(Count>=4) Part2=4;
	else Part2=Count;
	if(Part1>0)
	{
		l+=dynaOpLdrFull(cp+l,op0,op1,Immediate,Offset,Part1,Part2);
	}
	else
	{
		l+=dynaOpLdrHalf(cp+l,op0,op1,Immediate,Offset,Part2);
	}
	return(l);
}


unsigned __int16 dynaOpSdlFull(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1,unsigned __int32 Part2)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,PC_PTR);
	l+=CLD(cp+l);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,PC_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,PC_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,MEM_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,PC_PTR,tmp);
	l+=PUSH_REGISTER(cp+l,PC_PTR);
	tmp=4;
	l+=ADD_REG_IMM(cp+l,PC_PTR,tmp);		// src+4 (upper unsigned __int32)
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_REGISTER(cp+l,PC_PTR);
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part2);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	return(l);
}


unsigned __int16 dynaOpSdlHalf(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,PC_PTR);
	l+=CLD(cp+l);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,PC_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,PC_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,MEM_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,tmp);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	return(l);
}

unsigned __int16 dynaOpSdrFull(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1,unsigned __int32 Part2)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,PC_PTR);
	l+=STD(cp+l);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,PC_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,PC_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,MEM_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,PC_PTR,tmp);
	l+=PUSH_REGISTER(cp+l,PC_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_REGISTER(cp+l,PC_PTR);
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part2);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	l+=CLD(cp+l);
	return(l);
}


unsigned __int16 dynaOpSdrHalf(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,PC_PTR);
	l+=CLD(cp+l);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,PC_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,PC_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,MEM_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,tmp);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	return(l);
}

unsigned __int16 dynaOpSdl(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp+l);

	int Part1,Part2,Count;
	unsigned __int32 Offset;
	Offset=Immediate&7;
	Count=8-(int)Offset;
	Part1=Count-4;
	if(Count>=4) Part2=4;
	else Part2=Count;
	if(Part1>0)
	{
		l+=dynaOpSdlFull(cp+l,op0,op1,Immediate,Offset,Part1,Part2);
	}
	else
	{
		l+=dynaOpSdlHalf(cp+l,op0,op1,Immediate,Offset,Part2);
	}
	return(l);
}

unsigned __int16 dynaOpSdr(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp+l);

	int Part1,Part2,Count;
	unsigned __int32 Offset;
	Offset=Immediate&7;
	Count=8-(int)Offset;
	Part1=Count-4;
	if(Count>=4) Part2=4;
	else Part2=Count;
	if(Part1>0)
	{
		l+=dynaOpSdrFull(cp+l,op0,op1,Immediate,Offset,Part1,Part2);
	}
	else
	{
		l+=dynaOpSdrHalf(cp+l,op0,op1,Immediate,Offset,Part2);
	}
	return(l);
}

unsigned __int16 dynaOpLwlFull(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=CLD(cp+l);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,PC_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,PC_PTR,tmp);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	return(l);
}

unsigned __int16 dynaOpLwl(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp+l);

	int Count;
	unsigned __int32 Offset;
	Offset=Immediate&7;
	Count=8-(int)Offset;
	l+=dynaOpLwlFull(cp+l,op0,op1,Immediate,Offset,Count);
	return(l);
}


unsigned __int16 dynaOpLwrFull(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Count)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=STD(cp+l);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,PC_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,PC_PTR,tmp);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Count);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	l+=CLD(cp+l);
	return(l);
}

unsigned __int16 dynaOpLwr(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp+l);

	int Count;
	unsigned __int32 Offset;
	Offset=Immediate&3;
	Count=Offset+1;
	l+=dynaOpLwrFull(cp+l,op0,op1,Immediate,Offset,Count);
	return(l);
}


unsigned __int16 dynaOpSwlFull(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Part1)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,PC_PTR);
	l+=CLD(cp+l);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,PC_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,PC_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,MEM_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,tmp);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Part1);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	return(l);
}

unsigned __int16 dynaOpSwrFull(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate,unsigned __int32 Offset,unsigned __int32 Count)
{
	unsigned __int16 l=0;
	l+=PUSH_ALL(cp+l);
	l+=LOAD_REG(cp+l,op1,PC_PTR);
	l+=STD(cp+l);
	l+=ADD_REG_IMM(cp+l,PC_PTR,Immediate);
	l+=AND_REG_IMM(cp+l,PC_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,PC_PTR,(unsigned __int32) dynaRamPtr);
	unsigned __int32 tmp=op0*8;
	l+=NATIVE_REG_TO_REG(cp+l,MEM_PTR,REG_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,tmp);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Offset);		// dst+(offset%8)
	l+=LOAD_REG_IMM(cp+l,NATIVE_2,Count);
	l+=REP_MOVE_STORE_BYTE(cp+l);
	l+=POP_ALL(cp+l);
	l+=CLD(cp+l);
	return(l);
}

unsigned __int16 dynaOpSwr(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp+l);

	int Count;
	unsigned __int32 Offset;
	Offset=Immediate&3;
	Count=Offset+1;
	l+=dynaOpSwrFull(cp+l,op0,op1,Immediate,Offset,Count);
	return(l);
}


unsigned __int16 dynaOpSwl(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Immediate)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp+l);

	int Count;
	unsigned __int32 Offset;
	Offset=Immediate&7;
	Count=8-(int)Offset;
	l+=dynaOpSwlFull(cp+l,op0,op1,Immediate,Offset,Count);
	return(l);
}


unsigned __int16 dynaOpLl(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=STORE_REG_TO_RBANK(cp+l,MEM_PTR,CPR0+17*8);
	l+=LOAD_REG_IMM(cp+l,NATIVE_0,1);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,1972);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=STORE_REG(cp+l,op0,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpLwc1(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,_FPR+op0*4);
	return(l);
}

unsigned __int16 dynaOpLwc2(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,CPR1+op0*8);
	return(l);
}

unsigned __int16 dynaOpLdc1(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,_FPR+op0*4+4);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,4);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,_FPR+op0*4);
	return(l);
}

unsigned __int16 dynaOpLdc2(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,4);
	l+=LOAD_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,CPR1+op0*8+4);
	return(l);
}


unsigned __int16 dynaOpSwc1(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,_FPR+op0*4);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpSwc2(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,CPR1+op0*8);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpSdc1(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,_FPR+op0*4+4);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,4);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,_FPR+op0*4);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpSdc2(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr,*fixup2Ptr;
	unsigned __int16 fixup1l,fixup2l;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,CPR1+op0*8+4);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,4);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,CPR1+op0*8);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	return(l);
}

unsigned __int16 dynaOpSc(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr;
	unsigned __int16 fixup1Len;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_1,1972);
	unsigned __int32 tmp=1;
	l+=CMP_REG_IMM(cp+l,NATIVE_1,tmp);
	fixup1Ptr=cp+l;
	fixup1Len=l;
	l+=JNZ_SHORT(cp+l,0);
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=LOAD_REG(cp+l,op0,NATIVE_0);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	JNZ_SHORT(fixup1Ptr,(l-fixup1Len)-2);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_1,op0*8);
	return(l);
}


unsigned __int16 dynaOpScd(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned __int32 Imm)
{
	unsigned __int16 l=0;
	unsigned char *fixup1Ptr;
	unsigned __int16 fixup1Len;

	l+=INC_PC_COUNTER(cp+l);

	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_1,1972);
	unsigned __int32 tmp=1;
	l+=CMP_REG_IMM(cp+l,NATIVE_1,tmp);
	fixup1Ptr=cp+l;
	fixup1Len=l;
	l+=JNZ_SHORT(cp+l,0);
	l+=LOAD_REG(cp+l,op1,MEM_PTR);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_0,op0*8+4);
	l+=LOAD_REG_FROM_RBANK(cp+l,NATIVE_3,op0*8);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,Imm);
	l+=AND_REG_IMM(cp+l,MEM_PTR,0x003fffff);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,(unsigned __int32) dynaRamPtr);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_0);
	l+=ADD_REG_IMM(cp+l,MEM_PTR,4);
	l+=STORE_MEM_REG(cp+l,MEM_PTR,NATIVE_3);
	JNZ_SHORT(fixup1Ptr,(l-fixup1Len)-2);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_1,op0*8);
	return(l);
}

