#define TEX_ALPHA_COLORKEY_0	0
#define TEX_ALPHA_HIGHRGB		1

GLubyte pic[256][256][4];
GLubyte bufferpic[256][256][3];

typedef struct {
	char skip[2];
	char type[2];
	int size;
	WORD wres;
	WORD res;
	int offbits;
	int strsize;
} BMPheader;

typedef struct {
	int width;
	int height;
	WORD planes;
	WORD bitcount;
	int compression;
	int imagesize;
	int xppm;
	int yppm;
	int clrused;
	int clrimp;

} BMPinfo;

typedef struct {
	WORD width;
	WORD height;
	WORD planes;
	WORD bitcount;
} BMPcoreinfo;

BOOL GLSetupPalSupport( void );

void GLLoadRAW( char *filename, int tex_id, int x, int y );
void GLLoadBMP8( char *filename, int tex_id, int tex_mode );
